---
title: Create Azure scan options
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > Agentless Scanning
---

{% callout %}
# Important note for users on the following Datadog sites: app.ddog-gov.com, us2.ddog-gov.com

{% alert level="danger" %}
This product is not supported for your selected [Datadog site](https://docs.datadoghq.com/getting_started/site.md). ({% placeholder "user-datadog-site-name" /%}).
{% /alert %}

{% /callout %}

# Create Azure scan options{% #create-azure-scan-options %}
Copy pageCopied
{% tab title="v2" %}

| Datadog site      | API endpoint                                                                |
| ----------------- | --------------------------------------------------------------------------- |
| ap1.datadoghq.com | POST https://api.ap1.datadoghq.com/api/v2/agentless_scanning/accounts/azure |
| ap2.datadoghq.com | POST https://api.ap2.datadoghq.com/api/v2/agentless_scanning/accounts/azure |
| app.datadoghq.eu  | POST https://api.datadoghq.eu/api/v2/agentless_scanning/accounts/azure      |
| app.ddog-gov.com  | POST https://api.ddog-gov.com/api/v2/agentless_scanning/accounts/azure      |
| us2.ddog-gov.com  | POST https://api.us2.ddog-gov.com/api/v2/agentless_scanning/accounts/azure  |
| app.datadoghq.com | POST https://api.datadoghq.com/api/v2/agentless_scanning/accounts/azure     |
| us3.datadoghq.com | POST https://api.us3.datadoghq.com/api/v2/agentless_scanning/accounts/azure |
| us5.datadoghq.com | POST https://api.us5.datadoghq.com/api/v2/agentless_scanning/accounts/azure |

### Overview

Activate Agentless scan options for an Azure subscription.

OAuth apps require the `org_management` authorization [scope](https://docs.datadoghq.com/api/latest/scopes.md#agentless-scanning) to access this endpoint.



### Request

#### Body Data (required)



{% tab title="Model" %}

| Parent field | Field                  | Type    | Description                                                                                                          |
| ------------ | ---------------------- | ------- | -------------------------------------------------------------------------------------------------------------------- |
|              | data                   | object  | Single Azure scan options entry.                                                                                     |
| data         | attributes             | object  | Attributes for Azure scan options configuration.                                                                     |
| attributes   | compliance_host        | boolean | Indicates whether host compliance scanning is enabled.                                                               |
| attributes   | vuln_containers_os     | boolean | Indicates if scanning for vulnerabilities in containers is enabled.                                                  |
| attributes   | vuln_host_os           | boolean | Indicates if scanning for vulnerabilities in hosts is enabled.                                                       |
| data         | id [*required*]   | string  | The Azure subscription ID.                                                                                           |
| data         | type [*required*] | enum    | The type of the resource. The value should always be `azure_scan_options`. Allowed enum values: `azure_scan_options` |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "vuln_containers_os": true,
      "vuln_host_os": true
    },
    "id": "12345678-90ab-cdef-1234-567890abcdef",
    "type": "azure_scan_options"
  }
}
```

{% /tab %}

### Response

{% tab title="201" %}
Created
{% tab title="Model" %}
Response object containing Azure scan options for a single subscription.

| Parent field | Field                  | Type    | Description                                                                                                          |
| ------------ | ---------------------- | ------- | -------------------------------------------------------------------------------------------------------------------- |
|              | data                   | object  | Single Azure scan options entry.                                                                                     |
| data         | attributes             | object  | Attributes for Azure scan options configuration.                                                                     |
| attributes   | compliance_host        | boolean | Indicates whether host compliance scanning is enabled.                                                               |
| attributes   | vuln_containers_os     | boolean | Indicates if scanning for vulnerabilities in containers is enabled.                                                  |
| attributes   | vuln_host_os           | boolean | Indicates if scanning for vulnerabilities in hosts is enabled.                                                       |
| data         | id [*required*]   | string  | The Azure subscription ID.                                                                                           |
| data         | type [*required*] | enum    | The type of the resource. The value should always be `azure_scan_options`. Allowed enum values: `azure_scan_options` |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "compliance_host": false,
      "vuln_containers_os": true,
      "vuln_host_os": true
    },
    "id": "12345678-90ab-cdef-1234-567890abcdef",
    "type": "azure_scan_options"
  }
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                          \## default
# 
 \# Curl command curl -X POST "https://api.datadoghq.com/api/v2/agentless_scanning/accounts/azure" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \
-d @- << EOF
{
  "data": {
    "attributes": {
      "compliance_host": false,
      "vuln_containers_os": true,
      "vuln_host_os": true
    },
    "id": "12345678-90ab-cdef-1234-567890abcdef",
    "type": "azure_scan_options"
  }
}
EOF 
                        
##### 

```go
// Create Azure scan options returns "Created" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	body := datadogV2.AzureScanOptions{
		Data: &datadogV2.AzureScanOptionsData{
			Attributes: &datadogV2.AzureScanOptionsDataAttributes{
				VulnContainersOs: datadog.PtrBool(true),
				VulnHostOs:       datadog.PtrBool(true),
			},
			Id:   "12345678-90ab-cdef-1234-567890abcdef",
			Type: datadogV2.AZURESCANOPTIONSDATATYPE_AZURE_SCAN_OPTIONS,
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewAgentlessScanningApi(apiClient)
	resp, r, err := api.CreateAzureScanOptions(ctx, body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `AgentlessScanningApi.CreateAzureScanOptions`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `AgentlessScanningApi.CreateAzureScanOptions`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" go run "main.go"
##### 

```java
// Create Azure scan options returns "Created" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.AgentlessScanningApi;
import com.datadog.api.client.v2.model.AzureScanOptions;
import com.datadog.api.client.v2.model.AzureScanOptionsData;
import com.datadog.api.client.v2.model.AzureScanOptionsDataAttributes;
import com.datadog.api.client.v2.model.AzureScanOptionsDataType;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    AgentlessScanningApi apiInstance = new AgentlessScanningApi(defaultClient);

    AzureScanOptions body =
        new AzureScanOptions()
            .data(
                new AzureScanOptionsData()
                    .attributes(
                        new AzureScanOptionsDataAttributes()
                            .vulnContainersOs(true)
                            .vulnHostOs(true))
                    .id("12345678-90ab-cdef-1234-567890abcdef")
                    .type(AzureScanOptionsDataType.AZURE_SCAN_OPTIONS));

    try {
      AzureScanOptions result = apiInstance.createAzureScanOptions(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling AgentlessScanningApi#createAzureScanOptions");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" java "Example.java"
##### 

```python
"""
Create Azure scan options returns "Created" response
"""

from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.agentless_scanning_api import AgentlessScanningApi
from datadog_api_client.v2.model.azure_scan_options import AzureScanOptions
from datadog_api_client.v2.model.azure_scan_options_data import AzureScanOptionsData
from datadog_api_client.v2.model.azure_scan_options_data_attributes import AzureScanOptionsDataAttributes
from datadog_api_client.v2.model.azure_scan_options_data_type import AzureScanOptionsDataType

body = AzureScanOptions(
    data=AzureScanOptionsData(
        attributes=AzureScanOptionsDataAttributes(
            vuln_containers_os=True,
            vuln_host_os=True,
        ),
        id="12345678-90ab-cdef-1234-567890abcdef",
        type=AzureScanOptionsDataType.AZURE_SCAN_OPTIONS,
    ),
)

configuration = Configuration()
with ApiClient(configuration) as api_client:
    api_instance = AgentlessScanningApi(api_client)
    response = api_instance.create_azure_scan_options(body=body)

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" python3 "example.py"
##### 

```ruby
# Create Azure scan options returns "Created" response

require "datadog_api_client"
api_instance = DatadogAPIClient::V2::AgentlessScanningAPI.new

body = DatadogAPIClient::V2::AzureScanOptions.new({
  data: DatadogAPIClient::V2::AzureScanOptionsData.new({
    attributes: DatadogAPIClient::V2::AzureScanOptionsDataAttributes.new({
      vuln_containers_os: true,
      vuln_host_os: true,
    }),
    id: "12345678-90ab-cdef-1234-567890abcdef",
    type: DatadogAPIClient::V2::AzureScanOptionsDataType::AZURE_SCAN_OPTIONS,
  }),
})
p api_instance.create_azure_scan_options(body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" rb "example.rb"
##### 

```rust
// Create Azure scan options returns "Created" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_agentless_scanning::AgentlessScanningAPI;
use datadog_api_client::datadogV2::model::AzureScanOptions;
use datadog_api_client::datadogV2::model::AzureScanOptionsData;
use datadog_api_client::datadogV2::model::AzureScanOptionsDataAttributes;
use datadog_api_client::datadogV2::model::AzureScanOptionsDataType;

#[tokio::main]
async fn main() {
    let body = AzureScanOptions::new().data(
        AzureScanOptionsData::new(
            "12345678-90ab-cdef-1234-567890abcdef".to_string(),
            AzureScanOptionsDataType::AZURE_SCAN_OPTIONS,
        )
        .attributes(
            AzureScanOptionsDataAttributes::new()
                .vuln_containers_os(true)
                .vuln_host_os(true),
        ),
    );
    let configuration = datadog::Configuration::new();
    let api = AgentlessScanningAPI::with_config(configuration);
    let resp = api.create_azure_scan_options(body).await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run
##### 

```typescript
/**
 * Create Azure scan options returns "Created" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
const apiInstance = new v2.AgentlessScanningApi(configuration);

const params: v2.AgentlessScanningApiCreateAzureScanOptionsRequest = {
  body: {
    data: {
      attributes: {
        vulnContainersOs: true,
        vulnHostOs: true,
      },
      id: "12345678-90ab-cdef-1234-567890abcdef",
      type: "azure_scan_options",
    },
  },
};

apiInstance
  .createAzureScanOptions(params)
  .then((data: v2.AzureScanOptions) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" tsc "example.ts"
{% /tab %}
